---
title: "Etesync encrypted DAV server"

---

A small Etesync server that you can use to store your contacts, calendar and tasks, all encrypted (by your password of course).

## Warnings before using Etesync

Etesync is a good program, but lately, it hasn't been updated for like 9 months already (at the time of writing this, 2025-04-17), so please be aware of the security issues that an unmaintained project like this may have. For now, no security vulnerabilities has been found, but you will never know!

https://github.com/etesync/server/issues/196

## Why?

By default, if you have an Android phone, most of your contacts will be stored on your Google account (if you have a Google account linked to your phone, something that you shouldn't really do if you want to prevent Google for spying on you), this will make Google able to go trough all your contacts and use them as they like, maybe to create a profile about you, know most of the people you talk to, and also, private information about them (if you added that type on information on their contacts) like their birthday, their emails, their addresses and more information that you can include inside a contact. And if your Google account gets hacked for any reason, all you contacts will be exposed. Most of this also applies to your calendar events and tasks.

Etesync allows you to save all your contacts, calendar and tasks in a safe manner, you only need to trust on your own security since all the data it's encrypted (even contact images as far as I can see) using the password you supplied when you registered.

## How to use Etesync

Download Etesync from [F-droid](https://f-droid.org/packages/com.etesync.syncadapter/), install it, add an account, check the "Show advanced settings" checkbox and set it to `https://etebase.nadeko.net`

Set your username and password, and click "SIGN UP"

![](./etesync-android.jpg)

On PC, you can just enter to https://eteweb.nadeko.net and register an account from there.

If you want to be able to use Etesync on Thunderbird or any other program using DAV, it's not possible right now. I still need to setup https://github.com/etesync/etesync-dav. ETA? Maybe 1 month, sooner or later.

## How do I delete my account

Etesync, for some reason, makes it hard to delete account since they require hosting a "Dashboard" which doesn't appear to be open source. So if you want to "delete" your account, just delete everything you have on your Etesync account and leave the account as is. I'll try to look for a solution to this, but is not something I'm planing to do now or in the near future.